package nl.nikhef.sfp.i2c;

import java.io.IOException;

import nl.nikhef.rebus.ftdi.I2C;
import nl.nikhef.rebus.ftdi.MPSSE;

public class FTI2CLink implements I2CLink {


	private MPSSE _mpsse;
	private I2C   _i2c;
	
	public FTI2CLink(MPSSE mpsse) throws IOException {
		_mpsse = mpsse;
		_i2c   = new I2C(mpsse, I2C.SPEED_NORMAL, true);
		_i2c.wakeI2C();
	}
	
	
	@Override
	public void open() throws IOException
	{
		
	}

	@Override
	public void close() throws IOException 
	{
		
	}

	@Override
	public void i2cWrite(int addr, byte[] data) throws IOException {
		_i2c.write(addr, data);
	}

	@Override
	public byte[] i2cRead(int addr, int len) throws IOException {
		return _i2c.read(addr, len);
	}

	@Override
	public byte[] i2cWrRd(int addr, byte[] dataWr, boolean contRd, int rdLen)
			throws IOException {
		
		if (contRd) {
			i2cWrite(addr, dataWr);
			return i2cRead(addr, rdLen);
		} else {
			return _i2c.writeRead(addr, dataWr, rdLen);
		}
	}

	@Override
	public void shutdown() throws IOException {
		_mpsse.close();
	}

}
